unit uNim1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, mTSpielmanager, ExtCtrls;

const
  n = 13;
  k = 3;

type
  TForm1 = class(TForm)
    eSpieler1: TEdit; lSpieler1: TLabel;
    eSpieler2: TEdit; lSpieler2: TLabel;
    lBotschaft: TLabel; bNeuesSpiel: TButton;lH: TLabel;
    bNehmen: TButton;
    Shape1: TShape; Shape2: TShape; Shape3: TShape; Shape4: TShape;
    Shape5: TShape; Shape6: TShape; Shape7: TShape; Shape8: TShape;
    Shape9: TShape; Shape10: TShape; Shape11: TShape; Shape12: TShape;
    Shape13: TShape;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure bNeuesSpielClick(Sender: TObject);
    procedure bNehmenClick(Sender: TObject);
    procedure Shape1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    holz : array[1..n] of TShape;
    Spielmanager : TSpielmanager;
    freigegeben : boolean;
    procedure updateGUI;
    function markiert : integer;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  i : integer;
  s : string;
begin
  freigegeben := false;
  bNehmen.Enabled := false;
  SpielManager := TSpielmanager.Create;
  for i := 1 to n do
  begin
    s := 'Shape'+IntToStr(i);
    holz[i] := TShape(findcomponent(s));
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Spielmanager.Free;
end;

procedure TForm1.updateGUI;
begin
  lBotschaft.Caption := Spielmanager.GetBotschaft;
end;

procedure TForm1.bNeuesSpielClick(Sender: TObject);
var
  i : integer;
begin
  Spielmanager.neuesSpiel(eSpieler1.text,eSpieler2.text);
  for i := 1 to n do
    with holz[i] do
    begin
      brush.color := clWhite; visible := true;
    end;
  bNehmen.Enabled := false;
  freigegeben := true;
  updateGUI;
end;

procedure TForm1.bNehmenClick(Sender: TObject);
var
  e,i : integer;
begin
  e := markiert;
  for i := 1 to n do
    with holz[i] do
      if (brush.color = clRed) then visible := false;
  bNehmen.Enabled := false;
  Spielmanager.verarbeiteEingabe(e);
  updateGUI;
end;

function TForm1.markiert : integer;
var
  i : integer;
begin
  result := 0;
  for i := 1 to n do
    with holz[i] do
      if visible and (brush.color = clRed) then result := result+1;
end;

procedure TForm1.Shape1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if freigegeben and
     (TShape(Sender).Brush.Color = clWhite) and
     (markiert < k)
  then TShape(Sender).Brush.Color := clRed
  else TShape(Sender).Brush.Color := clWhite;
  if markiert > 0
  then bNehmen.Enabled := true
  else bNehmen.Enabled := false;
end;

end.
